/*	header files etc. for PUZZ		M.J.Round.	January 1990	*/

#define MAXLINE 80
#define MAXACROSS 32
#define MAXDOWN 32
#define MAXPIECES 256

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*	need undef to stop compiler giving snotty warning
	messages when NULL is redefined in exec/types.h
*/

#undef NULL

#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/io.h>
#include <exec/exec.h>
#include <exec/memory.h>
#include <exec/lists.h>
#include <exec/interrupts.h>
#include <exec/ports.h>
#include <exec/libraries.h>
#include <exec/tasks.h>
#include <exec/execbase.h>
#include <exec/devices.h>

#include <devices/input.h>
#include <devices/inputevent.h>
#include "devices/audio.h"

#include <intuition/intuition.h>

#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <graphics/copper.h>
#include <graphics/view.h>
#include <graphics/gels.h>
#include <graphics/regions.h>
#include <graphics/clip.h>
#include <graphics/text.h>
#include <graphics/gfxbase.h>

#include <devices/keymap.h>

#include <libraries/dos.h>
#include <libraries/diskfont.h>

#include <workbench/startup.h>

#include <proto/all.h>

typedef struct 
	{
	short w,h,x,y;
	char  nPlanes,masking,compression,pad1;
	short transparentColor;
	char  xAspect, yAspect;
	short pageWidth,pageHeight;
	} BitMapHeader;
