/*	sMOVIE.h	header file with all the include
				garbage for the sMOVIE program.
				M. J. Round.	 7 - Oct - 1989.		*/

#define CONFIGFILENAME1 ":sMOVIE.config"
#define CONFIGFILENAME2 "s:sMOVIE.config"

/*	program defaults	*/
#define DEFAULT_ESC_CHAR '|'
#define DEFAULTFONTNAME "topaz.font"
#define DEFAULTFONTHEIGHT 9
#define DEFAULTTABSIZE 8
#define DEFAULTDELAY 2
#define DEFAULTSPACING 2
#define DEFAULTBACKGROUNDCOLOUR 0,0,0
#define DEFAULTPENCOLOUR 15,15,15

/*	font limits	*/
#define MAXFONTS 20
#define MAXFONTNAMELENGTH 16

/*	input textlength limit	*/
#define MAXLINE 81

/*	view limits	*/
#define MIN_HEIGHT 1
#define MIN_WIDTH 34
#define MAX_HEIGHT 261
#define MAX_WIDTH 704
#define MAX_DEPTH 4

/*	mousemonitor limits	*/
#define MINDELAY 0
#define MAXDELAY 25
#define MOUSETHRESHOLD 30

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*	need undef to stop compiler giving snotty warning
	messages when NULL is redefined in exec/types.h		*/

#undef NULL

#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/io.h>
#include <exec/exec.h>
#include <exec/memory.h>
#include <exec/lists.h>
#include <exec/interrupts.h>
#include <exec/ports.h>
#include <exec/libraries.h>
#include <exec/tasks.h>
#include <exec/execbase.h>
#include <exec/devices.h>

#include <devices/input.h>
#include <devices/inputevent.h>

#include <intuition/intuition.h>

#include <hardware/dmabits.h>
#include <hardware/custom.h>
#include <hardware/blit.h>

#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <graphics/copper.h>
#include <graphics/view.h>
#include <graphics/gels.h>
#include <graphics/regions.h>
#include <graphics/clip.h>
#include <graphics/text.h>
#include <graphics/gfxbase.h>

#include <devices/keymap.h>

#include <libraries/dos.h>
#include <libraries/diskfont.h>

#include <workbench/startup.h>

#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>

typedef struct {
	int ypos;
	int button;		/*	left button toggles 0/1:, right button = -1	*/
	} MOUSE_INFO;
